$!
$! WPWHOIS_BUILD - This command procedure builds the wpwhois program.
$!                 It first calls a command proc to build the
$!                 dixie libraries.  Then it calls the procedure
$!                 to compile and link wpwhois.
$!
$! Args: P1 - additional qualifiers for the CC command
$!       P2 - Build dixie lib (Y/N)
$!       P3 - Build regexp lib (Y/N)
$!
$ dixdev=f$parse(f$env("procedure"),,,"DEVICE","NO_CONCEAL")
$ dixdir=f$parse(f$env("procedure"),,,"DIRECTORY","NO_CONCEAL")
$trashopen:
$ dixdir=dixdir-"["
$ if (f$locate("[",dixdir).ne.f$length(dixdir)) then goto trashopen
$trashclose:
$ dixdir=dixdir-"]"
$ if (f$locate("]",dixdir).ne.f$length(dixdir)) then goto trashclose
$ testdir=f$element(0,".",dixdir)
$ if testdir.nes."SYSCOMMON" then goto findir
$ topsys = F$TRNLNM( "SYS$TOPSYS", "LNM$SYSTEM" )
$ dixdir = topsys + "." + dixdir
$findir:
$ dixdir = f$extract(0,f$length(dixdir)-3,dixdir)
$ dixdir="["+dixdir+"]"
$ define/translation=(conceal,terminal) dixie_root 'dixdev''dixdir'
$ if f$search("dixie_root:[lib]dixie.h;*",1).eqs."" then set file dixie_root:[include]dixie.h/enter=dixie_root:[lib]dixie.h
$ if f$search("dixie_root:[wpwhois]dixie.h;*",2).eqs."" then set file dixie_root:[include]dixie.h/enter=dixie_root:[wpwhois]dixie.h
$ if f$search("dixie_root:[include.machine]types.h;*",3).eqs."" then copy sys$library:types.h dixie_root:[include.machine]
$ if (p2.eqs."")
$ then
$   inquire ans "Build dixie? "
$ else
$   ans=p2
$ endif
$ if ans.eqs."Y" then @dixie_root:[vms]build-dixie-lib.com "''p1'"
$ if (p3.eqs."")
$ then
$   inquire ans "Build regexp? "
$ else
$   ans=p3
$ endif
$ if ans.eqs."Y" then @dixie_root:[vms]build-regexp.com "''p1'"
$ @dixie_root:[vms]build-wpwhois.com "''p1'"
$ write sys$output "Done: WPWHOIS has been built"
$ write sys$output ""
$ write sys$output "To complete the installation, add the following line to"
$ write sys$output "your SYS$MANAGER:SYSTARTUP_V5.COM file:"
$ write sys$output ""
$ write sys$output "  $ DEFINE/SYSTEM/EXEC/TRANSLATION=(CONCEAL,TERMINAL) DIXIE_ROOT ''dixdev'''dixdir'"
$ write sys$output ""
$ write sys$output "Then add the following line to SYS$MANAGER:SYLOGIN.COM:"
$ write sys$output ""
$ write sys$output "  $ SET COMMAND DIXIE_ROOT:[VMS]WPWHOIS.CLD"
$ exit
