/*
 *  Copyright (c) 1990 Regents of the University of Michigan.
 *  All rights reserved.
 */

#ifndef lint 
static char copyright[] = "@(#) Copyright (c) 1990 Regents of the University of Michigan.\nAll rights reserved.\n";
#endif
     
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <dixie.h>
#include <regexp.h>
#ifdef VMS
#include <descrip.h>
#include <climsgdef.h>
#endif VMS
     
#define DEFAULT_SELECTIONS		20
#define MAX_SELECTIONS		        200

#ifdef VMS
#define LIMIT_LABEL_LEN         5
#define UPDATE_LABEL_LEN    6
#define DEBUG_LABEL_LEN             5
#endif VMS
      
     extern int yydebug;
     extern char *malloc();
     
     static jmp_buf env;
     
     int debug;
     FILE *morefp;
     
     char original_search_base[] = "@c=US@st=New Jersey@o=Rutgers University";
     char *search_base;
     
     int argflag = 0, whoisdflag = 0, limit = 0;
     int iidflag, lastname, rc, matches;
     char *crptr,*termtype;
     char inputbuf[255], filterstring[255];
     char answer[MAX_PKT_SIZE];
     char *who, *friendlydn, oldoptions;
     
     char *attrlist[] = {"title",NULL};
     char *readattrlist[] = {NULL};
     extern char *dxi_buffer, *dxi_dn2ufn(), *strchr(), dxi_options;
     
     
     main(argc, argv)
     int argc;
     char *argv[];
{
     extern int servers;
     extern FILE *morefp;
     extern int sigint();
     extern char *getenv();
     extern char *search_base, original_search_base[];
     extern char *optarg, *disambiguate();
     extern char *crptr, *termtype;
     int c, k, retval, updateflag = 0;
     char *inputptr;
     extern void update(), handle_search();
     extern int dxi_bound, dxi_debug;
     
     
#ifdef VMS
  char entity_string[256];
  $DESCRIPTOR (entity_desc, entity_string);
  char val_string[256];
  $DESCRIPTOR (val_desc, val_string);
  short val_length;
  char debugstr[256], limitstr[256];

  /* do args */
  unsigned long status;

  lib$movc3 (
    (unsigned short *) &UPDATE_LABEL_LEN,
    "UPDATE",
    entity_string);
  entity_desc.dsc$w_length = UPDATE_LABEL_LEN;
  status = cli$present (&entity_desc);
  switch (status) {
    case CLI$_PRESENT:
      updateflag = 1;
      break;

    case CLI$_NEGATED:
      updateflag = 0;
      break;

    default:
      updateflag = 0;
      break;
    };

  lib$movc3 (
    (unsigned short *) &DEBUG_LABEL_LEN,
    "DEBUG",
    entity_string);
  entity_desc.dsc$w_length = DEBUG_LABEL_LEN;
  status = cli$present (&entity_desc);
  switch (status) {
    case CLI$_PRESENT:
      status = cli$get_value (&entity_desc, &val_desc, &val_length);
      lib$movc3 (
      &val_length,
      val_desc.dsc$a_pointer,
          debugstr);
      debugstr[val_length] = '\0';
      debug = atoi(debugstr);
      dxi_debug = debug;
      break;

    case CLI$_NEGATED:
      debug = 0;
      dxi_debug = 0;
      break;

    default:
      debug = 0;
      dxi_debug = 0;
      break;
    };

  lib$movc3 (
    (unsigned short *) &LIMIT_LABEL_LEN,
    "LIMIT",
    entity_string);
  entity_desc.dsc$w_length = LIMIT_LABEL_LEN;
  status = cli$present (&entity_desc);
  if (status == CLI$_PRESENT) {
    status = cli$get_value (&entity_desc, &val_desc, &val_length);
    lib$movc3 (
    &val_length,
    val_desc.dsc$a_pointer,
        limitstr);
    limitstr[val_length] = '\0';
    limit = atoi(limitstr);
    };

#else VMS
     /* do args */
     while ((c = getopt(argc, argv, "wud:l:")) != EOF)
       switch (c) {
	  case 'd' :
	    debug = atoi(optarg);
	    dxi_debug = debug;
	    break;
	  case 'l' :
	    limit = atoi(optarg);
	    break;
	  case 'u' :
	    updateflag = 1;
	    break;
	  case 'w' :
	    whoisdflag = 1;
	    limit = MAX_SELECTIONS;
	    break;
       }
     
     k = 1;
     while ( k < argc) {
	  if ( *argv[k] != '-' ) {
	       if ( k > 1 )
		 strcat(inputbuf," ");
	       strcat(inputbuf,argv[k]);
	  }
	  k++;
     }
     
     if (strlen(inputbuf) > 0 ) {
	  argflag = 1;
     }
#endif VMS

     termtype = getenv("TERM");
     if ((search_base = (char *) malloc(strlen(original_search_base)+1)) == NULL){
	  perror("malloc");
	  exit(0);
     }
     strcpy(search_base, original_search_base);
     if ( limit == 0 ) {
       limit = DEFAULT_SELECTIONS;
     }
     dxi_init("whitepages.rutgers.edu",3,5);
     retval = dxi_bind("","",answer);
     if ( retval != 0 ) {
	  dxi_perror("");
	  printf("\nThe server is not currently reachable, please try again later.\n");
	  exit_ask(-1);
     }
     if ( ! updateflag && !whoisdflag && !argflag)
       print_header(); 
     
     signal(SIGINT, sigint);
#ifdef sparc     
     /* Fails somehow for Sun 3s */
     setjmp(env);
#endif
     
     if ( updateflag ) {
	  update();
	  exit(0);
     }
     else {
	  while ( 1) {
	       if ( ! updateflag && !whoisdflag && !argflag)
		 printf("\nType search (s) or quit (q) [s]: ");
	       if ( ! argflag ) {
		    bzero(inputbuf,sizeof(inputbuf));
		    inputptr = fgets(inputbuf,sizeof(inputbuf),stdin);
		    if ( inputptr <= 0)
		      break;
		    if (crptr = strchr(inputbuf,'\n'))
		      *crptr = '\0';
	       }
	       if ( ! updateflag && !whoisdflag && !argflag) {
		    if ( strcmp(inputbuf,"quit") == 0 || *inputbuf == 'q' || *inputbuf == EOF)
		      break;
		    
		    if ( strncmp(inputbuf,"search",strlen(inputbuf)) == 0 || strlen(inputbuf) == 0 ) {
			 printf("\nEnter the name of the person to search for: ");
			 bzero(inputbuf,sizeof(inputbuf));
			 fgets(inputbuf,sizeof(inputbuf),stdin);
		    }
		    if (crptr = strchr(inputbuf,'\n'))
		      *crptr = '\0';
		    if ( *inputbuf == '\0')
		      continue;
	       }
#ifdef VMS
	       morefp = stdout;
#else
	       if ( whoisdflag || (termtype != NULL && strncmp(termtype,"ibm-32",6) == 0))
		 morefp = stdout;
	       else
		 morefp = popen("/usr/ucb/more","w");
	       
#endif
	       (void) handle_search();
	       if ( whoisdflag || argflag) {
		    exit(0);
	       }
	  } /* end while() */
     } /* end of else from if for update test */
}

int
  sigint()
{
     fflush(stderr);
     fflush(stdout);
#ifdef sparc
     printf("\n\tud interrupted!\n");
     longjmp(env, 1);
#else
     exit(0);
#endif
}

#define STRINGLEN 255



print_header()
{
     printf("<========================= Whitepages Directory Search =======================>\n\n");
     printf("This is a program to search the Rutgers University Directory Service.\n");
     printf("The name of the person you wish to search for is required. Providing only\n");
     printf("the last name can cause the search to find many entries, so you need to\n");
     printf("provide a complete name in order to get a unique match. If more than one\n");
     printf("match occurs, you will be given a list of the first %d names to choose from.\n",limit);
     printf("This list will display the department that each person is associated with.\n");
     printf("The name of the person will be of the form Francis L Lawrence +FLL2+.\n");
     printf("The \"+FLL2+\" is a unique ID assigned to each person and may be used to\n");
     printf("find the persons entry. For example, you can search for \"Francis L Lawrence\",\n");
     printf("\"Francis Lawrence\", \"F Lawrence\", \"Lawrence\", or \"+FLL2+\" \n");
     printf("Note that case is not important, so using \"+fll2+\" is the same as \"+FLL2+\"\n");
     printf("\nIf you are a Rutgers employee and the information in your record is incorrect,\n");
     printf("you should submit an Address Directory Record (ADR) to the appropriate person\n");
     printf("within your department. Your department can provide the ADR form to you.\n");
     printf("\nIf you are a Rutgers student, and wish to change your entry, then you should\n");
     printf("go to the Verification Office, room 200L in the Administration Bldg. on\n");
     printf("Busch Campus and filling out a special form to request changes or an\n");
     printf("exclusion from being listed in the directory.\n");
}

char * disambiguate()
{
     int count = 0, choice, matches, i;
     char selection[10];
     char *choices[300];
     char *friendlydn;
     extern FILE *morefp;
     char *s, *entry, *temp, *temp2, *rdnstr, *spptr, *tmpptr;
     char instring[1024];
     int retval;
     regexp *r;

     /* present the selections */
     matches = dxi_matches(answer);
     entry = dxi_firstentry(answer);
     count = 0;
     bzero(instring,sizeof(instring));
     strcpy(instring,"^.*");
     tmpptr = malloc(strlen(inputbuf)+1);
     strcpy(tmpptr,inputbuf);
     crptr = tmpptr;
     while (*crptr != '\0') {
       if ( isascii(*crptr) )
	 *crptr = tolower(*crptr);
       crptr++;
     }
     while(spptr = strchr(tmpptr,' ')) {
	  *spptr = '\0';
	  tmpptr[0] = toupper(tmpptr[0]);
	  strcat(instring,tmpptr);
	  strcat(instring,".*");
	  tmpptr = ++spptr;
     }
     
     tmpptr[0] = toupper(tmpptr[0]);
     strcat(instring,tmpptr);
     strcat(instring,".*$");
     while (entry) {
	  s = dxi_getdn(entry);
	  temp = malloc(255);
	  strncpy(temp,s,255);
	  friendlydn = dxi_dn2ufn(s);
	  rdnstr = dxi_lastdncomp(temp);

	  r = regcomp(instring);
	  if (r == NULL ) {
	       fprintf(morefp,"failed to compile %s\n",instring);
	  }
	  if ( retval = regexec(r, rdnstr) == 1) {
	       choices[++count] = temp;
	       if ( count > limit )
		 break;
	  }
	  free(s);
	  entry = dxi_nextentry();
     }
     if ( count > limit ) {
	  fprintf(morefp,"\n***\n\nThere are more than %d entries. Displaying only the first %d!\n\n***\n\n",limit,limit);
     }
     if ( count == 0  ) {
	  entry = dxi_firstentry(answer);
	  while (entry && count < limit) {
	       s = dxi_getdn(entry);
	       temp = malloc(255);
	       strncpy(temp,s,255);
	       friendlydn = dxi_dn2ufn(s);
	       choices[++count] = temp;
	       free(s);
	       entry = dxi_nextentry();
	  }
     }
     if ( count == 2 ) {
       temp = malloc(255);
       temp2 = malloc(255);
       strcpy(temp,choices[1]);
       strcpy(temp2,choices[2]);
       if ( strcmp(dxi_lastdncomp(temp), dxi_lastdncomp(temp2)) == 0 && whoisdflag) {
	 for ( i=1 ; i < 3 ; i++ ) {
	       bzero(answer,MAX_PKT_SIZE);
	       retval = dxi_read(choices[i],readattrlist,answer);
	       if ( retval == -1 ) {
		    dxi_perror("");
		    exit(-1);
	       }
	       friendlydn = dxi_dn2ufn(choices[i]);
	       printf("\nName: %s\n\n",friendlydn);
	       free(friendlydn);
	       parse_answer(answer);
	       print_person();
	       fflush(stdout);
	     }
	 exit(0);
       }
     }
     if ( count == 1) {
	  if ( whoisdflag ) {
	       bzero(answer,MAX_PKT_SIZE);
	       retval = dxi_read(choices[1],readattrlist,answer);
	       if ( retval == -1 ) {
		    dxi_perror("");
		    exit(-1);
	       }
	       friendlydn = dxi_dn2ufn(choices[1]);
	       printf("\nName: %s\n\n",friendlydn);
	       free(friendlydn);
	       parse_answer(answer);
	       print_person();
	       fflush(stdout);
	       exit(0);
	  }
	  else
	    return(choices[1]);
     }
     else {
	  for(i=1;i<=count && i <=limit ;i++) {
	       temp = malloc(255);
	       strcpy(temp,choices[i]);
	       friendlydn = dxi_dn2ufn(temp);
	       if ( whoisdflag )
		 fprintf(morefp,"\n %s\n",friendlydn);
	       else
		 fprintf(morefp,"\n%2d -> %s\n", i,friendlydn);
	       free(temp);
	  }
     }
#ifndef VMS
     if ( morefp != stdout ) 
       pclose(morefp);
#endif
     if ( whoisdflag )
       exit(0);
     printf("\n\n");
     
     for (;;) {
	  
	  printf("Enter the number of the name to select,\n");
	  printf("or hit the return/enter key to return to the menu: ");
	  bzero(selection,sizeof(selection));
	  fgets(selection, sizeof(selection), stdin);
	  if (crptr = strchr(selection,'\n'))
	    *crptr = '\0';
	  
	  choice = atoi(selection);
	  if ((choice >= 0) && (choice <= count))
	    break;
	  else
	    printf("\tBad selection!\n");
     }
     
     if (choice != 0)
       {
	    temp = malloc (255);
	    strncpy (temp, choices[choice], 255);
       };
     for (i = 1;  i <= choice;  i++)
       {
	    free (choices[i]);
       };
     
     if (choice == 0) {
	  return(NULL);
     }
     else {
	  return(temp);
     }
}

exit_ask(val)
     int val;
{
     char selection[10];
     printf("\nType Return or Enter when done:");
     fgets(selection, sizeof(selection), stdin);
     exit(val);
}

void
  handle_search()
{
     regexp *r;

     /* handle CRs for whois mode */
     if (crptr = strchr(inputbuf,'
'))
       *crptr = '\0';
     r = regcomp(".*[0-9].*");
     iidflag =  regexec(r, inputbuf);
     if ( !iidflag && strchr(inputbuf,' ') == NULL )
       lastname = 1;
     else
       lastname = 0;
     
     bzero(filterstring,255);
     
     if ( !iidflag && lastname) {
	  strcpy(filterstring,"sn=");
	  strcat(filterstring,inputbuf);
     }
     else {
	  if ( iidflag == 1 ) {
	       if ( inputbuf[0] != '+' ) {
		    strcpy(filterstring,"uid=+");
		    strcat(filterstring,inputbuf);
		    strcat(filterstring,"+");
	       }
	       else {
		    strcpy(filterstring,"uid=");
		    strcat(filterstring,inputbuf);
	       }
	  }
	  else {
	       strcpy(filterstring,"cn~=");
	       strcat(filterstring,inputbuf);
	  }
     }
     bzero(answer,MAX_PKT_SIZE);
     rc = dxi_search(search_base,DXI_SRCH_SUBTREE,filterstring,attrlist,answer);
     if ( rc == -1 ) {
#ifndef VMS
	  if ( morefp != stdout) 
	    pclose(morefp);
#endif VMS
	  dxi_perror("");
	  exit_ask(-1);
     }
     
     matches = dxi_matches(answer);
     if ( matches == 0) {
	  char inchar[5];
	  if (lastname ) {
	       strcpy(filterstring,"cn=*");
	       strcat(filterstring,inputbuf);
	       strcat(filterstring,"*");
	       while(crptr = strchr(filterstring,' '))
		 *crptr = '*';
	       bzero(answer,MAX_PKT_SIZE);
	       rc = dxi_search(search_base,DXI_SRCH_SUBTREE,filterstring,attrlist,answer);
	       if ( rc == -1 ) {
#ifndef VMS
		    if ( morefp != stdout) 
		      pclose(morefp);
#endif VMS
		    dxi_perror("Search failed");
		    exit(-1);
	       }
	       matches = dxi_matches(answer);
	       if ( matches > 1 )
		 who = disambiguate();
	       else if ( matches == 1)
		 who = dxi_getdn(dxi_firstentry(answer));
	       else
		 who = NULL;
	       if ( who != NULL ) {
		    bzero(answer,MAX_PKT_SIZE);
		    rc = dxi_read(who,readattrlist,answer);
		    if ( rc == -1 ) {
			 dxi_perror("");
			 exit(-1);
		    }
		    friendlydn = dxi_dn2ufn(who);
		    printf("\nName: %s\n\n",friendlydn);
		    free(friendlydn);
		    parse_answer(answer);
		    print_person();
		    fflush(stdout);
	       }
	  }
#ifndef VMS
	  if ( morefp != stdout) 
	    pclose(morefp);
	  
#endif
	  if (matches != 0 )
	    return;

	  if ( ! whoisdflag )
	       printf("No matches were found, checking for an approximate match.\n\n");

#ifdef VMS
	  morefp = stdout;
#else
	  if ( whoisdflag || (termtype != NULL && strncmp(termtype,"ibm-32",6) == 0))
	    morefp = stdout;
	  else
	    morefp = popen("/usr/ucb/more","w");
	  
#endif
	  bzero(filterstring,255);

	  if ( lastname ) {
	       strcpy(filterstring,"sn~=");
	       strcat(filterstring,inputbuf);
	  }
	  else if ( iidflag ) {
	       strcpy(filterstring,"cn~=");
	       strcat(filterstring,inputbuf);
	  }
	  else {
	    int spcount = 0;
	    char *tmpptr, *spptr;
	    tmpptr = inputbuf;
	    if (spptr = strtok(tmpptr," ") ) {
	      strcpy(filterstring,"cn~=");
	      strcat(filterstring,spptr);
	      if( spptr = strtok(NULL," ")) {
		strcat(filterstring,spptr);
	      }
	      if ( ! (spptr = strtok(NULL," "))) {
		fprintf(morefp,"No approximate matches were found.\n");
#ifndef VMS
		pclose(morefp);
#endif VMS
		return;
	      }
	      strcat(filterstring," ");
	      strcat(filterstring,spptr);
	      while (spptr = strtok(NULL, " ")) {
		strcat(filterstring," ");
		strcat(filterstring,spptr);
	      }
	    }
	  }
	  bzero(answer,MAX_PKT_SIZE);
	  rc = dxi_search(search_base,DXI_SRCH_SUBTREE,filterstring,attrlist,answer);
	  if ( rc == -1 ) {
	       
#ifndef VMS
	       if ( morefp != stdout)
		 pclose(morefp);
	       
#endif
	       dxi_perror("");
	       exit_ask(-1);
	  }
	  
	  matches = dxi_matches(answer);
	  if ( matches == 0 ) {
#ifndef VMS
	       if ( morefp != stdout)
		 pclose(morefp);
#endif
	       printf("No matches found.\n");
	       return;
	  }
     }
     if (matches > 1 ) {
	  who = disambiguate();
     }
     if ( matches == 1)
       who = dxi_getdn(dxi_firstentry(answer));
     
#ifndef VMS
     if ( morefp != stdout) 
       pclose(morefp);
#endif
     
     if ( who != NULL ) {
	  bzero(answer,MAX_PKT_SIZE);
	  rc = dxi_read(who,readattrlist,answer);
	  if ( rc == -1 ) {
	       dxi_perror("");
	       exit_ask(-1);
	  }
	  friendlydn = dxi_dn2ufn(who);
	  printf("\nName: %s\n\n",friendlydn);
	  free(friendlydn);
	  parse_answer(answer);
	  print_person();
	  fflush(stdout);
     }
}
